//+---------------------------------------------------------------------------------------------------------------+
//|                                    Dynamic Trader Data Exporter.mq4 Ver 2.0                                   |
//|                                         Copyright  2012, Mahdi Yazdi                                         |
//+---------------------------------------------------------------------------------------------------------------+
#property copyright "Copyright  2012/09, Mahdi Yazdi."
#property indicator_chart_window

extern bool M1_Scan  = false,
            M5_Scan  = true,
            M15_Scan = true,
            M30_Scan = true,
            H1_Scan  = true,
            H4_Scan  = true,
            D1_Scan  = true,
            W1_Scan  = true,
            MN1_Scan = false;

datetime  Last_scan;

//+---------------------------------------------------------------------------------------------------------------+
//+---- initiate and deinitiate Functions    ---------------------------------------------------------------------+
//+---------------------------------------------------------------------------------------------------------------+
int init()
  {
   ObjectCreate("DT_Name", OBJ_LABEL, 0,0,0);
   ObjectSetText("DT_Name", "DT Data Exporter", 8,"", White);
   ObjectSet("DT_Name", OBJPROP_CORNER, 2);
   ObjectSet("DT_Name", OBJPROP_XDISTANCE, 3);
   ObjectSet("DT_Name", OBJPROP_YDISTANCE, 1);
   Last_scan = TimeMinute(iTime(Symbol(), PERIOD_M1, 2));
   return(0);
  }
int deinit()
  {
   ObjectDelete("DT_Name");
   return(0);
  }
//+---------------------------------------------------------------------------------------------------------------+
//+---- Start Function    ----------------------------------------------------------------------------------------+
//+---------------------------------------------------------------------------------------------------------------+
int start()
  {
   if (TimeMinute(iTime(Symbol(),PERIOD_M1,1)) != Last_scan)
      {
       if (M1_Scan)  CreateFile(PERIOD_M1);
       if (M5_Scan)  CreateFile(PERIOD_M5);
       if (M15_Scan) CreateFile(PERIOD_M15);
       if (M30_Scan) CreateFile(PERIOD_M30);
       if (H1_Scan)  CreateFile(PERIOD_H1);
       if (H4_Scan)  CreateFile(PERIOD_H4);
       if (D1_Scan)  CreateFile(PERIOD_D1);
       if (W1_Scan)  CreateFile(PERIOD_W1);
       if (MN1_Scan) CreateFile(PERIOD_MN1);
       Last_scan = TimeMinute(iTime(Symbol(),PERIOD_M1,1));
      }
   return(0);
  }
//+---------------------------------------------------------------------------------------------------------------+
//+---- Craete Output File             ---------------------------------------------------------------------------+
//+---------------------------------------------------------------------------------------------------------------+
void CreateFile(int _timeframe)
  {
   int fp;
   string outstring;
   string file_name, idxdate, idxtime;

   file_name = "DT_"+Symbol()+"_"+GetTimeText(_timeframe)+ ".prn";
   fp = FileOpen(file_name , FILE_CSV|FILE_WRITE, ",");
   if(fp < 1)
     { Print("can not open file. error-"+GetLastError());
       return(0);
     }
   int j = MathMin(iBars(Symbol(), _timeframe), 2500);
   for(int i=j; i>=0; i--)
      {
       if(i==j) 
         { FileWrite(fp, "<DTYYYYMMDD>,<TIME>,<OPEN>,<HIGH>,<LOW>,<CLOSE>,<VOL>");
           continue;
         }
       idxdate = TimeToStr(iTime(NULL, _timeframe,i), TIME_DATE);
       idxtime = TimeToStr(iTime(NULL, _timeframe,i), TIME_SECONDS);
       outstring = StringSubstr(idxdate,0,4)+StringSubstr(idxdate,5,2)+StringSubstr(idxdate,8,2) +","+
                   StringSubstr(idxtime,0,2)+StringSubstr(idxtime,3,2)+StringSubstr(idxtime,6,2) +","+
                   DoubleToStr(iOpen(NULL, _timeframe,i), Digits) +","+ 
                   DoubleToStr(iHigh(NULL, _timeframe,i), Digits) +","+ 
                   DoubleToStr(iLow(NULL, _timeframe,i), Digits) +","+ 
                   DoubleToStr(iClose(NULL, _timeframe,i), Digits) +","+ 
                   DoubleToStr(iVolume(NULL, _timeframe,i), 0);

       FileWrite(fp, outstring);
      }
   FileClose(fp);
   return(0);
  }
//+---------------------------------------------------------------------------------------------------------------+
//+---- Getting Time Text    -------------------------------------------------------------------------------------+
//+---------------------------------------------------------------------------------------------------------------+
string GetTimeText(int _timeframe)
 {
  switch (_timeframe) {
     case PERIOD_M1 :  return ("M1");
     case PERIOD_M5 :  return ("M5");
     case PERIOD_M15:  return ("M15");
     case PERIOD_M30:  return ("M30");
     case PERIOD_H1 :  return ("H1");
     case PERIOD_H4 :  return ("H4");
     case PERIOD_D1 :  return ("D1");
     case PERIOD_W1 :  return ("W1");
     case PERIOD_MN1:  return ("MN1");
  }
  return(0);
 }
//+---------------------------------------------------------------------------------------------------------------+

